local _PATH = (...):match('^(.*[%./])[^%.%/]+$') or ''

local hero = {}
hero.__index = hero

local function new(x, y, screen)
	x, y = x or 0, y or 0
	size = 15
	t = 0
	alpha = 0
	weapon = {}
	armory = {}
	enemies = {}
	score = 0
	screen = screen or {}
	png = screen.png.hero or {}
	return setmetatable({
		x = x, y = y,
		size = size,
		t = t,
		alpha = alpha,
		weapon = weapon,
		armory = armory,
		enemies = enemies,
		score = score,
		png = png,
		screen = screen
	}, hero)
end

function hero:update(dt)
	-- mise  jour du hros
	-- self.t = self.t + dt
	-- if self.t > self.size / 99 then
		-- self.t = 0
		if love.keyboard.isDown('w') then self.y = self.y - self.size * 14 * dt end
		if love.keyboard.isDown('s') then self.y = self.y + self.size * 14 * dt end
		if love.keyboard.isDown('a') then self.x = self.x - self.size * 14 * dt end
		if love.keyboard.isDown('d') then self.x = self.x + self.size * 14 * dt end
	-- end
	self.alpha = math.angle(self.x, self.y, self.screen:getPosition())
	-- mise  jour de l'arme
	for i, v in ipairs(self.armory) do v:update(dt) end
	if love.keyboard.isDown('1') then self.weapon = self.armory[1] end
	if love.keyboard.isDown('2') then self.weapon = self.armory[2] end
	if love.keyboard.isDown('3') then self.weapon = self.armory[3] end
	-- mise  jour des ennemis
	for i, v in ipairs(self.enemies) do v:update(dt) end
	table.sort(self.enemies, compDistance)
	-- actions
	if love.mouse.isDown('l') and self.weapon.t > self.weapon.cadence then
		self.weapon.t = 0
		self.weapon:setRays()
		for i, v in ipairs(self.enemies) do
			if #self.weapon.rays == 0 or v.distance > self.weapon.range then break end
			if self.weapon:isHitting(v) then v:isHittedBy(self.weapon) end
		end
	end
	-- nettoyage des morts
	for i, v in ipairs(self.enemies) do
		if v.isDead then table.remove(self.enemies, i) end
	end
end

function hero:drawAttached()
	self.weapon:draw()
	setWhite()
	scale = self.size / self.png:getWidth()
	az, er = math.rotate(-self.size / 2, -self.size / 2, self.alpha)
	love.graphics.draw(self.png, self.x + az, self.y + er, self.alpha, scale, scale)
end

function hero:drawDetached()
	love.graphics.print(self.score, 16, 16)
	love.graphics.rectangle('fill', love.mouse.getX() - self.size / 6, love.mouse.getY() - self.size / 6, self.size / 3, self.size / 3)
end

function compDistance(a, b) if a.distance < b.distance then return true else return false end end

-- the module
return setmetatable({new = new}, {__call = function(_, ...) return new(...) end})	