Seed = require 'seed'
Hero = require 'hero'
Swarm = require 'swarm'
Weapon = require 'weapon'
Screen = require 'screen'
Message = require 'message'
Road = require 'road'
require 'color'
require 'math_addon'

function love.load()
	screen = Screen()
	sms = {}
	-- hros
	hero = Hero(400, 400, screen)
	table.insert(hero.armory, Weapon(hero, 3, 0.1, 7, 3, 250, 0.50, 0.125, 15)) -- shootgun
	table.insert(hero.armory, Weapon(hero, 4, 0.01, 500, 3, 1000, 0.95, 0.05, 1)) -- rifle
	table.insert(hero.armory, Weapon(hero, 7, 0.33, 7, 3, 500, 1, 1, 50)) -- grenade
	hero.weapon = hero.armory[2]
	screen.target = hero
	-- ennemis
	swarms = {}
	-- route
	road = Road(screen, 400, 400, -math.pi / 16, {3, 'right', 2, 'left', 2, 'right', 'right', 7, 'right', 4, 'right'})
	road:draw()
end

function love.update(dt)
	while #hero.enemies < 5e2 do
		local swarm = Swarm(hero, 5e2, screen)
		swarm:addSeeds(1e2)
		table.insert(swarms, swarm)
	end	
	if love.keyboard.isDown('e') then for i, v in ipairs(swarms) do v.mode = 'expand' end end
	if love.keyboard.isDown('r') then for i, v in ipairs(swarms) do v.mode = 'run' end end
	if love.keyboard.isDown('g') then for i, v in ipairs(swarms) do v.mode = 'group' end end
	if love.keyboard.isDown('c') then for i, v in ipairs(swarms) do v.mode = 'circle' end end
	if love.keyboard.isDown('f') then for i, v in ipairs(swarms) do v.mode = 'flee' end end
	hero:update(dt)
	for i = 1, #sms do sms[i]:update(dt) end
	i = 1 while sms[i] do if sms[i].finish then table.remove(sms, i) else i = i + 1 end end
	i = 1 while swarms[i] do if swarms[i].volume == 0 then table.remove(swarms, i) else i = i + 1 end end
end

function love.draw()
	screen:attach()
	screen:drawBackground()
	-- tiler:setShaderOn()
	for i, v in ipairs(hero.enemies) do v:draw() end
	hero:drawAttached()
	-- tiler:setShaderOff()
	screen:detach()
	hero:drawDetached()
end

function love.keypressed(key)
	-- if key == 'g' then if render.isShaded then render.isShaded = false else render.isShaded = true end end
	if key == 'escape' then love.event.quit() end
end