function math.norm(x, y)
	return math.sqrt(math.pow(x, 2) + math.pow(y, 2))
end

function math.normalized(x, y)
	if math.norm(x, y) == 0 then return 0, 0
	else return x / math.norm(x, y), y / math.norm(x, y) end
end

function math.normalize(x, y, n)
	local nx, ny = math.normalized(x, y)
	return n * nx, n * ny
end

function math.angle(x1, y1, x2, y2)
	if y2 < y1 then return -math.acos(math.normalized(x2 - x1, y2 - y1))
	else return math.acos(math.normalized(x2 - x1, y2 - y1)) end
end

function math.rotate(x, y, a, cx, cy)
	if cx and cy then return (x - cx) * math.cos(a) - (y - cy) * math.sin(a) + cx, (x - cx) * math.sin(a) + (y - cy) * math.cos(a) + cy
	else return x * math.cos(a) - y * math.sin(a), x * math.sin(a) + y * math.cos(a) end
end

function math.randomData(data) return data[math.random(1, #data)] end