local _PATH = (...):match('^(.*[%./])[^%.%/]+$') or ''

local message = {}
message.__index = message

local function new(x, y, h, str, t)
	x, y = x or 0, y or 0
	h = h or 200
	str = str or ''
	t = t or 2
	dt = 0
	finish = false
	return setmetatable({
		x = x, y = y,
		h = h,
		str = str,
		t = t, dt = dt,
		finish = finish
	}, message)
end

function message:update(dt)
	self.dt = self.dt + dt
	if self.dt > self.t then self.dt = self.t self.finish = true end
end

function message:draw()
	love.graphics.setColor((1 - (self.dt / self.t)) * 255, (1 - (self.dt / self.t)) * 255, (1 - (self.dt / self.t)) * 255, (1 - (self.dt / self.t)) * 255)
	love.graphics.print(self.str, self.x, self.y - self.h * (self.dt / self.t))
end

-- the module
return setmetatable({new = new}, {__call = function(_, ...) return new(...) end})