local _PATH = (...):match('^(.*[%./])[^%.%/]+$') or ''

local weapon = {}
weapon.__index = weapon

local function new(carrier, damage, cadence, loader, reload, range, precision, dispersion, shots)
	-- parameters
	carrier = carrier or {}
	damage = damage or 11
	cadence = cadence or 0.25
	loader = loader or 25
	reload = reload or 3
	range = range or 500
	precision = precision or 0.875
	dispersion = dispersion or 0.25
	shots = shots or 25
	
	-- needed
	t = 0
	victim = {distance = 9e9}
	rays = {}
	toDraw = {}
	alpha = 0
	return setmetatable({
		carrier = carrier,
		damage = damage,
		cadence = cadence,
		loader = loader,
		reload = reload,
		range = range,
		precision = precision,
		dispersion = dispersion,
		shots = shots,
		
		t = t,
		precisionRay = precisionRay,
		dispersionRay = dispersionRay,
		victim = victim,
		rays = rays,
		toDraw = toDraw,
		alpha = alpha
	}, weapon)
end

function weapon:update(dt)
	self.t = self.t + dt
end

function weapon:setRays()
	self.rays = {}
	self.toDraw = {}
	local ray = 0
	for i = 1, self.shots do
		ray = self.carrier.alpha + ((math.pi * self.dispersion) / self.shots) * (2 * i - 1 - self.shots + (1 - self.precision) * (-1 + 2 * math.random()))
		while ray < -math.pi do ray = ray + 2 * math.pi end
		while ray > math.pi do ray = ray - 2 * math.pi end
		table.insert(self.rays, ray)
	end
end

function weapon:isHitting(target)
	for i, v in ipairs(self.rays) do
		if math.abs(v - target.alpha) < math.atan((target.size / 2) / target.distance) then
			local r = 40 + math.random(-10, 10)
			if target.distance > 110 then
				local angle = math.angle(self.carrier.x, self.carrier.y, target.x, target.y)
				-- table.insert(self.toDraw, {self.carrier.x + r * math.cos(angle), self.carrier.y + r * math.sin(angle), target.x - r * math.cos(angle), target.y - r * math.sin(angle)})
				table.insert(self.toDraw, {self.carrier.x + (target.x - self.carrier.x) * 0.1,
										   self.carrier.y + (target.y - self.carrier.y) * 0.1,
										   self.carrier.x + (target.x - self.carrier.x) * 0.9,
										   self.carrier.y + (target.y - self.carrier.y) * 0.9})
			end
			table.remove(self.rays, i)
			return true
		end
	end
	return false
end

function weapon:draw()
	love.graphics.setColor(155, 155, 155, 155)
	for i, v in ipairs(self.toDraw) do
		love.graphics.line(v)
	end
end

-- the module
return setmetatable({new = new}, {__call = function(_, ...) return new(...) end})